/**
 * @class Node
 *
 * A DOM node. [See the DOM specification for more](http://www.w3.org/TR/dom/#node).
 */

/**
 * @class CharacterData
 * @extends Node
 *
 * Some character data, usually a string. [See the DOM specification for more](http://www.w3.org/TR/dom/#characterdata).
 */

/**
 * @class CommentNode
 * @extends CharacterData
 *
 * A comment node. [See the DOM specification for more](http://www.w3.org/TR/dom/#comment).
 */

/**
 * @class Document
 * @extends Node
 *
 * A DOM Document. [See the DOM specification for more](http://www.w3.org/TR/dom/#document).
 */

/**
 * @class Element
 * @extends Node
 *
 * An HTML element. [See the DOM specification for more](http://www.w3.org/TR/dom/#element).
 */

/**
 * @class TextNode
 * @extends CharacterData
 *
 * A text node. [See the DOM specification for more](http://www.w3.org/TR/dom/#text).
 */

/**
 * @class EventEmitter
 *
 * An event-emitting object. [See the Node.js documentation for more](http://nodejs.org/api/events.html#events_class_events_eventemitter).
 */

/**
 * @class Response
 *
 * A Response object for the express application. [See the express documentation for more](http://expressjs.com/api.html#res.status).
 */

/**
 * @class Request
 *
 * A Request object for the express application. [See the express documentation for more](http://expressjs.com/api.html#req.params).
 */

/**
 * @class Map
 *
 * The Map object is a simple key/value map. Any value (both objects
 * and primitive values) may be used as either a key or a value.
 * [See MDN for more information](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Map).
 */

/**
 * @class Set
 *
 * The Set object lets you store unique values of any type, whether
 * primitive values or object references.
 * [See MDN for more information](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Set).
 */

/**
 * @class Promise
 *
 * The Promise object is used for deferred and asynchronous
 * computations. A Promise represents an operation that hasn't
 * completed yet, but is expected to in the future.
 * [See MDN for more information](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise).
 */
